;                                               
;                          ____    ____         
;                    MCLR |    \__/    | B7  PGD
;    LED 2 zeleni <--  A0 |            | B6  PGC
;                      A1 |            | B5 --> LED 1 crveni
;                      A2 |            | B4     
;                      A3 |            | B3     
;                      A4 |            | B2     
;                      A5 |    2525    | B1     
;                     Vss |            | B0 <-- jumper
;             16 MHz  Osc |            | Vdd    
;             16 MHz  Osc |            | Vss    
;                      C0 |            | C7 <-- RXD
;           CLOCK -->  C1 |            | C6 --> TXD
;        RFID OUT <--  C2 |            | C5     
;         RFID IN -->  C3 |____________| C4     
;                                               

	LIST P=18F2525
	#include <P18F2525.INC>

#define datain	portc,3		; ext pullup
#define dataout	latc,2
#define	clockin	portc,1		; direktno 125 KHz sa izlaza
#define	led_1	latb,5		; crveni
#define	led_2	lata,0		; zeleni
#define	jumper	portb,0

	config osc = HS
	config fcmen = off
	config ieso = off
	config pwrt = on
	config borv = 1
	config wdt = off
	config mclre = off
	config lpt1osc = off
	config pbaden = off
	config stvren = on
	config lvp = off
	config xinst = off
	config debug = off
	config cp0 = off
	config cp1 = off
	config cp2 = off
	config cpb = off
	config cpd = off
	config wrt0 = on
	config wrt1 = on
	config wrt2 = on
	config wrtb = on
	config wrtc = on
	config wrtd = off
	config ebtr0 = off
	config ebtr1 = off
	config ebtr2 = off
	config ebtrb = off

	CBLOCK	0

tempw
inner
outer
clkcount
rdbuf1:	8
rdbuf2:	8
bytes:	6

	ENDC

;_____________________________________________________________

	org	0
	nop
	goto	main
;--------
paritytab 	; 10=parity error
	;	 0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
	db	00h,10h,10h,03h,10h,05h,06h,10h,10h,09h,0ah,10h,0ch,10h,10h,0fh
	db	10h,01h,02h,10h,04h,10h,10h,07h,08h,10h,10h,0bh,10h,0dh,0eh,10h
;--------
main:
	movlw	0fh
	movwf	adcon1
	movlw	7
	movwf	cmcon

	movlw	b'00100110'
	movwf	txsta		; reg TXREG
	movlw	b'10010000'
	movwf	rcsta		; reg RCREG
	movlw	.208
	movwf	spbrg		; 4800 bd (osc 16 MHz)
	bcf	intcon2,rbpu	; enable internal pullups

;	movlw	b'10000011'	; t0 on, 16-bit, prescaler 1:16 (oko 3,81 Hz)
;	movwf	t0con		; timer0 (flag intcon,tmr0if)

	clrf	lata
	clrf	latb
	clrf	latc
	movlw	B'11000000'
	movwf	trisa
	movlw	B'00000001'
	movwf	trisb
	movlw	B'10001010'	; RX, RFID data, RFID clock inputs
	movwf	trisc
				; ___ clear ram bank 0
	clrf	fsr1h
	clrf	fsr2h
	lfsr	fsr0,0
goclr256
	clrf	postinc0
	btfss	fsr0h,0
	goto	goclr256

;_____________________________________

	clrf	tblptrh
	clrf	tblptru
	bsf	led_1		; ugasi crveni led
	bsf	led_2		; ugasi zeleni led
	bsf	dataout
	call	ms12

;______________________________________________          _________________
;______________________________________________  FARM 1  _________________

farm1
rdagn1
	bcf	led_1		; upali crveni led
	bsf	led_2		; ugasi zeleni led

rdagn0
	call	readall
	bc	rdagn1

	movff	rdbuf1+0,rdbuf2+0
	movff	rdbuf1+1,rdbuf2+1
	movff	rdbuf1+2,rdbuf2+2
	movff	rdbuf1+3,rdbuf2+3
	movff	rdbuf1+4,rdbuf2+4
	movff	rdbuf1+5,rdbuf2+5
	movff	rdbuf1+6,rdbuf2+6
	movff	rdbuf1+7,rdbuf2+7

	call	readall
	bc	rdagn1
				; POREDJENJE RDBUF1 i RDBUF2
	lfsr	fsr0,rdbuf1
	lfsr	fsr1,rdbuf2
	movlw	.8
	movwf	inner
cp8a
	movf	postinc0,w
	cpfseq	postinc1
	bra	rdagn1		; ne slazu se dva zapisa - sve ispocetka!

	decfsz	inner,f
	bra	cp8a
				; ovde ima kartice

;--- 0
	call	rotate		; shift out header bit
	call	getnib
	btfsc	wreg,4
	goto	rdagn1		; parity error
	swapf	wreg,f
	movwf	bytes+0		; hi nib 0

	call	getnib5
	btfsc	wreg,4
	goto	rdagn1		; parity error
	iorwf	bytes+0,f	; lo nib 0
;--- 1
	call	getnib5
	btfsc	wreg,4
	goto	rdagn1		; parity error
	swapf	wreg,f
	movwf	bytes+1		; hi nib 1

	call	getnib5
	btfsc	wreg,4
	goto	rdagn1		; parity error
	iorwf	bytes+1,f	; lo nib 1
;--- 2
	call	getnib5
	btfsc	wreg,4
	goto	rdagn1		; parity error
	swapf	wreg,f
	movwf	bytes+2		; hi nib 2

	call	getnib5
	btfsc	wreg,4
	goto	rdagn1		; parity error
	iorwf	bytes+2,f	; lo nib 2
;--- 3
	call	getnib5
	btfsc	wreg,4
	goto	rdagn1		; parity error
	swapf	wreg,f
	movwf	bytes+3		; hi nib 3

	call	getnib5
	btfsc	wreg,4
	goto	rdagn1		; parity error
	iorwf	bytes+3,f	; lo nib 3
;--- 4
	call	getnib5
	btfsc	wreg,4
	goto	rdagn1		; parity error
	swapf	wreg,f
	movwf	bytes+4		; hi nib 4

	call	getnib5
	btfsc	wreg,4
	goto	rdagn1		; parity error
	iorwf	bytes+4,f	; lo nib 5
;---
	bsf	led_1		; ugasi crveni led
	bcf	led_2		; upali zeleni led
rdagn11
	lfsr	fsr0,bytes+0
	movlw	0a5h
	call	txbyte232
	movlw	0c3h
	call	txbyte232
	movf	postinc0,w
	call	txbyte232
	movf	postinc0,w
	call	txbyte232
	movf	postinc0,w
	call	txbyte232
	movf	postinc0,w
	call	txbyte232
	movf	postinc0,w
	call	txbyte232

	goto	rdagn0


;-----------------------
txbyte232
	btfss	pir1,txif
	bra	txbyte232	; jer tx vec salje (txif=1 if txreg=empty)
	movwf	txreg		; SEND BYTE *******************
	return

;_________________________________

readall
	lfsr	fsr0,rdbuf1
skrrd
	clrf	postinc0
	clrf	postinc0
	clrf	postinc0
	clrf	postinc0
	clrf	postinc0
	clrf	postinc0
	clrf	postinc0
	clrf	postinc0


	call	measure
	bc	errflag		; error was flagged
nomatch
;	call	biphase		; samo jedan od ova dva poziva ostaje!
	call	manchester	; samo jedan od ova dva poziva ostaje!

	bc	errflag		; error was flagged

	btfsc	rdbuf1+7,7
	bra	nomatch		; stop bit 0 not detected

	incf	rdbuf1+0,w
	bnz	nomatch		; prvih 8 header bitova 11111111 not detected

	btfss	rdbuf1+1,0
	bra	nomatch		; 9-ti header bit 1 not detected
	bcf	status,c	; flag ok
	return
errflag
	bsf	status,c	; flag error
	return

;_________________________________

manchester		; one bit manchester (pripremiti FSR0)
	movlw	.48		; pocetak cekanja ivice
	call	wclocks
	movlw	.32		; kraj cekanja ivice
	btfss	datain
	bra	nowlo
				; ovde je datain hi
find0
	call	oneclock
	btfss	datain
	bra	found1		; nasao opadajucu ivicu na vreme
	decfsz	wreg,f
	bra	find0
	goto	errbit		; isteklo vreme (2 ms), nema opadajuce ivice
nowlo				; ovde je datain lo
find1
	call	oneclock
	btfsc	datain
	bra	found0		; nasao rastucu ivicu na vreme
	decfsz	wreg,f
	bra	find1
	goto	errbit		; isteklo vreme (2 ms), nema opadajuce ivice

;biphase			; one bit biphase (pripremiti FSR0)
;	call	measure
;	bc	errbit		; greska - period duzi od 255 perioda osc
;	addlw	-46
;	bc	long		; if long period    0000000000000
;	call	measure
;	bc	errbit		; greska - period duzi od 255 perioda osc
;	addlw	-46
;	bc	errbit		; greska - dugi posle kratkog perioda

found1
	bsf	status,c	; bit 1             1111111111111
	bra	rotate
long				;                   0000000000000
	addlw	46
	addlw	-94
	bc	errbit		; too long peirod (>96)
found0
	bcf	status,c	; bit 0
rotate
	lfsr	fsr0,rdbuf1+7
	rrcf	postdec0,f
	rrcf	postdec0,f
	rrcf	postdec0,f
	rrcf	postdec0,f
	rrcf	postdec0,f
	rrcf	postdec0,f
	rrcf	postdec0,f
	rrcf	postdec0,f
	bcf	status,c	; flag ok
	return

errbit
	bsf	status,c	; flag error
	return

;-------
measure				; meri tajming do prve promene
	clrf	clkcount
	btfss	datain
	bra	nowlow
hagn01				; ceka nizak nivo i broji taktove ++++++
	call	oneclock
	incf	clkcount,f
	bz	hovf01		; 256 clocks
	btfsc	datain
	bra	hagn01		; datain HIGH
	movf	clkcount,w	; w=duzina signala u punim periodama clocka
	bcf	status,c	; flag it OK
	return
hovf01
	movlw	.255		; flag it overflow
	bsf	status,c
	return

nowlow				; ceka visok nivo i broji taktove  ------
lagn01
	call	oneclock
	incf	clkcount,f
	bz	lovf01		; 256 clocks
	btfss	datain
	bra	lagn01		; datain LOW
	movf	clkcount,w	; w=duzina signala u punim periodama clocka
	bcf	status,c	; flag it OK
	return
lovf01
	movlw	.255		; flag it overflow
	bsf	status,c
	return

;_________________________________ 

wclocks
	call	oneclock
	decfsz	wreg,f
	bra	wclocks
	return
;--------
oneclock
w01
	btfss	clockin
	bra	w01
w02
	btfsc	clockin
	bra	w02
	return
;-------
ms12w				; loop w * 12ms
	call	ms12
	decfsz	wreg,f
	bra	ms12w
	return

;--------
ms1				; loop oko 1 ms
	clrf	inner
	clrf	outer
	bsf	outer,4		; outer = 16 za 1 ms
	bra	goms10
ms12				; loop 12 ms
	clrf	inner
	clrf	outer
	bsf	outer,6		; outer = 64 za 12 ms
goms10
	decfsz	inner,f
	bra	goms10
	decfsz	outer,f
	bra	goms10
	return
;--------
getnib5
	call	rotate
	call	rotate
	call	rotate
	call	rotate
	call	rotate
getnib
	movf	rdbuf1+1,w
	andlw	1fh
	addlw	paritytab
	movwf	tblptrl
	tblrd*
	movf	tablat,w
	return




	END